@if (componentData$ | async; as componentData) {
  <div class="full-width full-height" sqtmCoreAnchorResize>
    <div
      class="full-width full-height p-r-15 overflow-y-auto"
      sqtmCoreAnchorScroll
    >
      <div class="flex-column full-width" [sqtmCoreAnchorPanel]="'charter'">
        <div class="panel-title">
          {{ 'sqtm-core.test-case-workspace.title.charter' | translate }}
        </div>
        <div class="flex-fixed-size">
          @if (componentData.execution.exploratorySessionOverviewInfo.charter) {
            @if (extendedCharter) {
              <div class="charter p-10">
                <div class="m-b-10">
                  <i
                    class="m-r-10"
                    nz-icon
                    nzType="{{ 'caret-down' }}"
                    nzTheme="outline"
                    [attr.data-test-element-id]="'toggle-charter'"
                    (click)="toggleCharter()"
                  ></i>
                  <span class="header-typography">{{
                    'sqtm-core.test-case-workspace.title.charter' | translate
                  }}</span>
                </div>
                <div
                  class="m-l-10"
                  [attr.data-test-element-id]="'extended-charter-value'"
                  [innerHTML]="
                    componentData.execution.exploratorySessionOverviewInfo
                      .charter | safeRichContent
                  "
                ></div>
              </div>
            } @else {
              <div class="charter charter-collapsed">
                <div class="flex-row full-height p-10 vertical-center">
                  <i
                    class="m-r-10"
                    nz-icon
                    nzType="caret-right"
                    nzTheme="outline"
                    [attr.data-test-element-id]="'toggle-charter'"
                    (click)="toggleCharter()"
                  ></i>
                  <span class="header-typography m-t-auto"
                    >{{
                      'sqtm-core.test-case-workspace.title.charter' | translate
                    }}
                    :</span
                  >
                  <div
                    class="charter-collapsed-text m-l-10"
                    [attr.data-test-element-id]="'collapsed-charter-value'"
                    [innerHTML]="
                      componentData.execution.exploratorySessionOverviewInfo
                        .charter
                    "
                  ></div>
                </div>
              </div>
            }
          } @else {
            <div
              class="container-background-color container-border p-10 m-t-10 m-b-5"
            >
              <span class="empty-panel-placeholder">
                {{
                  'sqtm-core.campaign-workspace.exploratory-execution.no-charter'
                    | translate
                }}
              </span>
            </div>
          }
        </div>
        <ng-template #charter>
          @if (extendedCharter) {
            <div class="charter p-10">
              <div class="m-b-10">
                <i
                  class="m-r-10"
                  nz-icon
                  nzType="{{ 'caret-down' }}"
                  nzTheme="outline"
                  [attr.data-test-element-id]="'toggle-charter'"
                  (click)="toggleCharter()"
                ></i>
                <span class="header-typography">{{
                  'sqtm-core.test-case-workspace.title.charter' | translate
                }}</span>
              </div>
              <div
                class="m-l-10"
                [attr.data-test-element-id]="'extended-charter-value'"
                [innerHTML]="
                  componentData.execution.exploratorySessionOverviewInfo.charter
                    | safeRichContent
                "
              ></div>
            </div>
          } @else {
            <div class="charter charter-collapsed">
              <div class="flex-row full-height p-10 vertical-center">
                <i
                  class="m-r-10"
                  nz-icon
                  nzType="caret-right"
                  nzTheme="outline"
                  [attr.data-test-element-id]="'toggle-charter'"
                  (click)="toggleCharter()"
                ></i>
                <span class="header-typography m-t-auto"
                  >{{
                    'sqtm-core.test-case-workspace.title.charter' | translate
                  }}
                  :</span
                >
                <div
                  class="charter-collapsed-text m-l-10"
                  [attr.data-test-element-id]="'collapsed-charter-value'"
                  [innerHTML]="
                    componentData.execution.exploratorySessionOverviewInfo
                      .charter
                  "
                ></div>
              </div>
            </div>
          }
        </ng-template>
        @if (componentData.execution.taskDivision !== null) {
          <div class="full-width flex-fixed-size p-10 m-b-20 task-division">
            <div class="label label-color">
              {{
                'sqtm-core.campaign-workspace.exploratory-execution.task-division'
                  | translate
              }}&nbsp;:
            </div>
            <div
              class="p-l-15"
              [attr.data-test-element-id]="'task-division-value'"
            >
              {{ componentData.execution.taskDivision }}
            </div>
          </div>
        }
      </div>
      <div
        class="flex-column full-width p-t-10"
        [sqtmCoreAnchorPanel]="'notes'"
        sqtmCoreAnchorLastPanel
      >
        <div class="flex-row align-center">
          <div class="panel-title notes-title">
            {{ 'sqtm-core.test-case-workspace.title.notes' | translate }}
          </div>
          <div class="m-l-auto flex align-center">
            <div style="width: 180px">
              <sqtm-core-grouped-multi-list-field
                [searchable]="false"
                [listItems]="noteKindItems"
                (valueChanged)="selectedKindsChanged($event)"
                [placeHolder]="
                  'sqtm-core.campaign-workspace.execution-page.note.filter-kinds'
                    | translate
                "
                [showClearButton]="true"
              ></sqtm-core-grouped-multi-list-field>
            </div>
            <div class="m-l-10">
              <a
                [attr.data-test-element-id]="'collapse-all-notes'"
                (click)="collapseAllNotes()"
              >
                <i
                  nz-icon
                  nzType="sqtm-core-generic:zoom-out"
                  nzTheme="outline"
                  class="action-icon-size current-workspace-button"
                  [nz-tooltip]="
                    'sqtm-core.test-case-workspace.test-steps.button.collapse-all'
                      | translate
                  "
                >
                </i>
              </a>
              <a
                [attr.data-test-element-id]="'expand-all-notes'"
                (click)="expandAllNotes()"
                class="m-l-10 current-workspace-button"
              >
                <i
                  nz-icon
                  nzType="sqtm-core-generic:zoom-in"
                  nzTheme="outline"
                  class="action-icon-size"
                  nzTooltipPlacement="topRight"
                  [nz-tooltip]="
                    'sqtm-core.test-case-workspace.test-steps.button.expand-all'
                      | translate
                  "
                >
                </i>
              </a>
            </div>
          </div>
        </div>
        @if (
          getSessionNotesCount(componentData) || isSessionRunning(componentData)
        ) {
          <div
            class="full-width flex-fixed-size"
            [attr.data-test-element-id]="'session-note-list'"
            [sqtmCoreDraggableList]="origin"
            [dragEnabled]="true"
            [draggedContentRenderer]="draggedSessionNotesComponent"
            (dragStart)="dragStart($event)"
            (dragOver)="dragOver($event)"
            (dragCancel)="dragCancel()"
            (dragLeave)="dragLeave()"
            (drop)="drop(componentData.execution.id)"
          >
            @if (filteredNotes; as notes) {
              @for (note of notes; track trackNotesFn($index, note)) {
                <ng-container
                  [ngTemplateOutlet]="
                    isExistingNote(note) ? existingNote : newNote
                  "
                  [ngTemplateOutletContext]="{
                    note: note,
                    index: note.displayOrder + 1
                  }"
                >
                </ng-container>
              }
              <div
                class="last-position"
                [sqtmCoreDraggableListItem]="lastPositionDropZone"
                [enableDrag]="false"
              ></div>
            }
            <ng-template #existingNote let-note="note">
              <sqtm-app-session-note-container
                [sessionNote]="note"
                [index]="note.displayOrder + 1"
                (refreshIssuesData)="loadIssuesData(componentData.execution.id)"
                [canDragAndDrop]="canMove(componentData)"
                [canMove]="canMove(componentData)"
                [canAttach]="
                  canEdit(componentData) && !isSessionStopped(componentData)
                "
              >
                <sqtm-app-session-note
                  (addButtonClicked)="handleAddButtonClicked()"
                  (refreshIssuesData)="
                    loadIssuesData(componentData.execution.id)
                  "
                  [issues]="getIssuesForNote(note)"
                  [authenticatedToBugtracker]="authenticated$ | async"
                  [note]="note"
                  [editable]="canEdit(componentData)"
                  [isSessionStopped]="isSessionStopped(componentData)"
                  [isSessionRunning]="isSessionRunning(componentData)"
                >
                </sqtm-app-session-note>
              </sqtm-app-session-note-container>
            </ng-template>
            <ng-template #newNote let-index="index">
              @if (canAddNote(componentData)) {
                <sqtm-app-session-note-container
                  [index]="index"
                  [canMove]="canMove(componentData)"
                  [canDragAndDrop]="false"
                >
                  <div class="p-10" #newNoteContainer>
                    <sqtm-app-session-note-kind-select
                      class="m-b-10"
                      [isAddNote]="true"
                      [editable]="true"
                      [noteKind]="newNoteKind"
                      (noteKindSelectionChanged)="handleNoteKindChange($event)"
                    >
                    </sqtm-app-session-note-kind-select>
                    <sqtm-core-rich-text-field
                      #newNoteContentField
                      [attr.data-test-element-id]="'content'"
                      [formGroup]="formGroup"
                      [fieldName]="'newNoteContent'"
                    >
                    </sqtm-core-rich-text-field>
                    <div class="m-t-10">
                      <button
                        [attr.data-test-element-id]="'confirm-button'"
                        class="flex-fixed-size"
                        nz-button
                        nzType="primary"
                        (click)="addNewNote(index - 1)"
                      >
                        {{ 'sqtm-core.generic.label.confirm' | translate }}
                      </button>
                      @if (
                        index !==
                        componentData.execution.sessionNotes.ids.length
                      ) {
                        <button
                          class="flex-fixed-size m-l-10"
                          nz-button
                          nzType="default"
                          (click)="cancelNewNote()"
                        >
                          {{ 'sqtm-core.generic.label.cancel' | translate }}
                        </button>
                      }
                    </div>
                  </div>
                </sqtm-app-session-note-container>
              }
            </ng-template>
          </div>
        } @else {
          <div
            class="container-background-color container-border p-x-30 p-y-15 m-t-10"
          >
            <span class="empty-panel-placeholder">
              {{
                'sqtm-core.campaign-workspace.exploratory-execution.no-existing-note'
                  | translate
              }}
            </span>
          </div>
        }
      </div>
      <div id="sqtm-core-ghost-div" sqtmCoreAnchorGhostDiv></div>
    </div>
  </div>
}
